#ifndef RQ_DECOMPOSITION_H_
#define RQ_DECOMPOSITION_H_

// library includings
#include "num_linalg.h"

// own includings
#include "MatrixOperations.h"
#include "TransformMatrices.h"

namespace Basics3D
{
	void RQDecomposition(Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_R,
			                 Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &out_Q,
			                 const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_M);

}

#endif //RQ_DECOMPOSITION_
