#ifndef _DEBUG_TEST_H 
#define _DEBUG_TEST_H 

#include <time.h>
#include <strstream>
namespace Vtl
{
namespace Dbg
{
class TimeElapsed
{
   clock_t _st,_fin;
public:
	TimeElapsed() {start();}
	void start() 
	{

		_st=_fin=clock();
	}
	void finish()
	{
		_fin=clock();
	}
	double Get()
	{
		return double(double(_fin - _st)/CLOCKS_PER_SEC);
	}
	std::string GetString()
	{
		std::ostringstream os;
		os << "Time elapsed " << Get() << " sec." ;
		return os.str();
	}
};
}//namespace Dbg
}//namespace Vtl
#endif //_DEBUG_TEST_H 
