#include "ywin.h"
//#include "yfile.h"
#include "yfilesys.h"

bool DllModule::LoadLibrary(const char *dll_full_name)
{
	if(dll!=NULL)
		this->FreeLibrary();
	dll=::LoadLibrary(dll_full_name);
	return (dll!=NULL);
}

bool DllModule::LoadLibrary(const char *dll_name,const char *dll_path)
{//if dll_path==NULL load from app root dir
//	char name[MAX_PATH];
//	char dir[MAX_PATH];
	std::string name;
	std::string dir;
	if(dll_path!=NULL && dll_name!=NULL)
	{
/*
		::strcpy(name,YFileName::GetNameExt(dll_name));
		YFileName::GetDrDir(dll_path,dir);
		::strcat(dir,name);
*/
		name=YFileSys::getName(dll_name);
		dir=YFileSys::getDir(dll_path);
		dir+=name;
	}
	else if(dll_path==NULL && dll_name!=NULL)
	{
		dir=dll_name;
/*
		if(YFileName::IsFullName(dll_name))
			::strcpy(dir,dll_name);
		else
		{
////In OCX no __argv exist
//			::strcpy(name,YFileName::GetNameExt(dll_name));
//			YFileName::GetDrDir(__argv[0],dir);
//			::strcat(dir,name);
//
			::strcpy(dir,dll_name);
		}
*/
	}
	else //if(dll_path!=NULL && dll_name==NULL)
	{
		throw "DllModule::LoadLibrary(): dll_path!=NULL && dll_name==NULL";
	}
/*
	if(YFileName::IsFileExist(dir))
		return this->LoadLibrary(dir);
*/
	if(YFileSys::isFileExist(dir))
		return this->LoadLibrary(dir.c_str());
	else
		throw "DllModule::LoadLibrary(): dll file not found";
#ifndef __BORLANDC__
	return false;
#endif
}

void DllModule::FreeLibrary()
{
	if(dll!=NULL)
	{
		::FreeLibrary(dll);
		dll=NULL;
	}
}
FARPROC DllModule::GetProcAddress(const char *fun_name)
const
{
	if(dll!=NULL)
		return ::GetProcAddress(dll,fun_name);
	else
		return 0;
}
