#ifndef _FOURIER_H
#define _FOURIER_H
#include "imagemem.h"
class FFT_2D
{
public:
	static void FFT(AImageMemFloat *Re,AImageMemFloat *Im,bool reverse);
	// 	
	static AImageMemFloat* Image2Float(AImage* img,bool make2power=true);
	//FFT works only on images with sizes equal to 2**N, param 'make2power' adjust it
	static void Float2Image(AImageMemFloat *fi,AImageMem8* img,bool logarithimic=true,bool autoscale=true, float A=1,float B=0);
	static void ReIm2AmpPhase(AImageMemFloat *ReAmp,AImageMemFloat *ImPhase);
	static void AmpPhase2ReIm(AImageMemFloat *ReAmp,AImageMemFloat *ImPhase);
	static void TransposeQuarters(AImageMemFloat *img);
	static  void CalcSize(AImage *img,int *Fourier_width,int *Fourier_height);
	static void GetLeftTopPosAtFFT(AImage* img,int *Fourier_left,int *Fourier_top);
	static int Transform2Power(int size);
	// -  ..    CalcSize;
	static bool ChekImages(AImage *ReAmp,AImage *ImPhase,bool chekpower); 
private:	
	static void fourn(float *Redata, float *Imdata,int nn[],bool reverse);
};

#endif //_FOURIER_H
