#ifndef EPIPOLE_H
#define EPIPOLE_H

//library includings
#include "num_linalg.h"

//own includings
#include "SolveSystem.h"
#include "Point2D.h"

namespace Basics3D
{
  class C_Epipole
	{
	public:
	  static void Left(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out_e,
			               const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_F);

		static void Right(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &out_e,
			                const Vtl::NumAlg::Lin::ublas::c_matrix<double, 3, 3> &in_F);

		static void Normalize(Vtl::NumAlg::Lin::ublas::c_vector<double, 3> &in_out);
	};
}

#endif //EPIPOLE_H
