//#include <sstream>
#include "datastring.h"

/*
DataString& DataString::operator=(int val)
{
	std::ostringstream os;
	os << val;
	*this=os.str();
	return *this;
}
DataString::operator int() const
{
	std::istringstream is(*this);
	int val;
	is >> val;
	return val;
}
*/
std::string DataString::TimeToString(YDataTime val,YTimeInterval zone,int sec_digits)
{
	std::ostringstream os;
	os.width(4);
	os.fill('0');
	os << val.Year()<<"-";
	os.width(2);
	os.fill('0');
	os << val.Month()<<"-";
	os.width(2);
	os.fill('0');
	os << val.Day()<<"T";
	os.width(2);
	os.fill('0');
	os << val.Hour()<<":";
	os.width(2);
	os.fill('0');
	os << val.Minutes()<<":";
	int sec=int(val.Seconds());
	os.width(2);
	os.fill('0');
	os << sec <<".";
	int mult=1;
	for(int i=0; i<sec_digits; ++i)
		mult*=10;
	sec=unsigned((val.Seconds()-sec)*mult);
	os.width(sec_digits);
	os.fill('0');
	os << sec ;
	if(zone==YTimeInterval(0))
		os <<"Z+00:00";
	else
	{
		int days;
		int hours;
		int minutes;
		double sec;
		YTimeInterval z=(zone<YTimeInterval(0))?-zone:zone;
		z.Get(days,hours,minutes,sec);
		os << "Z" << ((zone<YTimeInterval(0))?"-":"+");
		os.width(2);
		os.fill('0');
		os << hours <<":";
		os.width(2);
		os.fill('0');
		os << minutes;
	}
	return os.str();
}

void DataString::StringToTime(std::string str,YDataTime& val,YTimeInterval& zone)
{
	int year,month,day,hour,minutes;
	double seconds;
	int tzone_h,tzone_m;
	char c;
	std::istringstream is(str);
	is>>year;
	is>>c;
	if(c=='-')
	{
		is>>month;
		is>>c;
		if(c=='-')
		{
			is>>day;
			is>>c;
			if(c=='T')
			{
				is>>hour;
				is>>c;
				if(c==':')
				{
					is>>minutes;
					is>>c;
					if(c==':')
					{
						is>>seconds;
						if(is.eof())
						{
							val.Set(year,month,day,hour,minutes,seconds);
							return;
						}
						else 
						{
							is>>c;
							if(c=='Z')
							{
								is>>tzone_h;
								is>>c;
								if(c==':')
								{
									is>>tzone_m;
									if(is.eof() || isspace(is.peek()) )
									{
										YDataTime dt(year,month,day,hour,minutes,seconds);
										YTimeInterval ti;
										ti.Set(0,tzone_h,tzone_m,0.0);
										zone=ti;
										val=dt;
/*
										bool neg=(tzone_h<0)?true:false;
										if(neg)
										{
											ti.Set(0,-tzone_h,tzone_m,0.0);
											dt+=ti;
										}
										else
										{
											ti.Set(0,tzone_h,tzone_m,0.0);
											dt-=ti;
										}
										return dt;
*/
									}
								}
							}
						}
					}
				}
			}
		}

	}
	throw "Invalid data";
}

