#ifndef _YWIN_H
#define _YWIN_H
////////////////////////////////////////////////////////////////////////
#include <windows.h>
#define DLL_FUN _cdecl
////////////////////////////////////////////////////////////////////////
class DllModule
{
	HINSTANCE dll; 
public:
	DllModule() { dll=NULL; }
	virtual ~DllModule() { FreeLibrary(); }
	bool IsOk() const { return (dll!=NULL); }
	bool LoadLibrary(const char *dll_full_name);
	bool LoadLibrary(const char *dll_name,const char *dll_path);//if dll_path==NULL load from app root dir
	void FreeLibrary();
	FARPROC GetProcAddress(const char *fun_name) const;
};
////////////////////////////////////////////////////////////////////////
#endif //_YWIN_H
