clc;
clear;
disp('Program IntTransf_1.m started');

n=2;
while n<=32
    %n=16;
    sigma=n/2/8;
    sum=0;
    for j=1:n
        x=(j-n/2-1)/sigma ;
        re(j)=(1./sqrt(2*pi)/sigma)*exp(-x*x/2);
        sum=sum+re(j);
    end
    for j=1:n
        re(j)=re(j)/sum;
    end
    im(1:n)=0;
    f=re+i*im;
    fs = fftshift(f);
    FUS=fft(fs,n);
    F=fftshift(FUS);
    FT=F';
    ft=f';
    reFT=real(FT);
    imFT=imag(FT);
    D=[reFT,imFT];
    fname=sprintf('%s%02d%s','gauss_fft_',n,'.dat');
    save(fname,'D','-ASCII');
    n=n*2;
end


